<template>
    <div>
        <div class="alert alert-success" role="alert" v-if="orderPosted">
            Your order has been received. The delivery information will be notified through your email and phone.
            <router-link to="/shop"><a>Shop More</a></router-link>
        </div>

        <ul class="list-group" v-if="itemsInCart && itemsInCart.length">
            <li class="list-group-item clearfix" v-for="items of itemsInCart" :key="items.id">
                <p class="float-left">{{items.productName}}</p>
                <div class="float-right clearfix">
                    <p class="float-left">Rs.{{items.price}}</p>
                    <p class="float-left">* {{items.quantity}}</p>
                </div>
            </li>
            <p style="text-align: end" class="alert alert-dark">Total Amount: Rs. {{totalAmount}}</p>
        </ul>

        <form style="margin: 40px 0" @submit.prevent="onCheckout" v-if="!orderPosted">

            <div class="form-group">
                <label for="deliveryAdd">Delivery Address</label>
                <input type="text"
                       class="form-control"
                       id="deliveryAdd"
                       placeholder="Enter address"
                       v-model="deliveryAdd"
                       @blur="$v.deliveryAdd.$touch()"
                       :class="{'is-invalid': $v.deliveryAdd.$error}"/>
                <span class="invalid-feedback">
                        <span v-if="!$v.deliveryAdd.required">
                            Please enter the delivery address.
                        </span>
                    </span>
            </div>

            <button class="btn btn-primary"
                    type="submit"
                    style="width:80px"
                    :disabled="$v.$invalid">
                Confirm
            </button>
        </form>
    </div>
</template>

<script>
    import {mapGetters} from 'vuex';
    import {required} from 'vuelidate/lib/validators';
    import axios from "axios";

    export default {
        data() {
            return {
                orderPosted: false,
                deliveryAdd: '',
                status: 'publish'
            }
        },
        validations: {
            deliveryAdd: {
                required
            }
        },
        computed: {
            ...mapGetters([
                'itemsInCart',
                'totalAmount',
                'username'
            ])
        },
        methods: {
            onCheckout() {
                let data = [];
                for(let item of this.itemsInCart) {
                    data.push({
                        product_id: item.id,
                        quantity: item.quantity
                    })
                }
                const formData = new FormData();
                formData.append('username', this.username);
                formData.append('items_in_cart', JSON.stringify(data));
                formData.append('total_amount', this.totalAmount);
                formData.append('delivery_address', this.deliveryAdd);
                axios.post('http://localhost:8000/api/addToCart.php', formData)
                    .then(() => {
                        this.orderPosted = true;
                        this.$store.state.itemsInCart = [];
                    }).catch((err) => {
                    console.log(err);
                });
            }
        }
    }
</script>